unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  {--------------------------------------------------------------------------------}
  {--- On a cinq maisons alignes de couleurs diffrentes.                      ---}
  {--- Dans chaque maison vit une personne de nationalit diffrente.           ---}
  {--- Chaque personne boit une boisson diffrente.                             ---}
  {--- Chaque personne fume un type de cigarette diffrente.                    ---}
  {--- Chaque personne lve un animal diffrent.                               ---}
  {--- Il faut trouver qui lve les poissons.                                  ---}
  {--- indices:                                                                 ---}
  {---  1) L'anglais vit dans la maison rouge                                   ---}
  {---  2) Le sudois lve des chiens                                          ---}
  {---  3) Le danois boit du th.                                               ---}
  {---  4) La maison verte est juste  gauche de la maison blanche.             ---}
  {---  5) Le propritaire de la maison verte boit du caf.                     ---}
  {---  6) Le fumeur de Pall Mall lve des oiseaux.                            ---}
  {---  7) Le propritaire de la maison jaune fume des Dunhills.                ---}
  {---  8) L'homme qui vit dans la maison du centre boit du lait.               ---}
  {---  9) Le norvgien vit dans la premire maison.                            ---}
  {--- 10) L'homme qui fume des Blends vit  ct de celui qui lve des chats. ---}
  {--- 11) L'homme qui lve des chevaux vit  ct du fumeur de Dunhills.      ---}
  {--- 12) L'homme qui fume des Blue Masters boit de la bire.                  ---}
  {--- 13) L'allemand fume des Prince.                                          ---}
  {--- 14) Le norvgien vit  ct de la maison bleue.                          ---}
  {--- 15) L'homme qui fume des Blends a un voisin qui boit de l'eau.           ---}
  {--------------------------------------------------------------------------------}

  { 120^5 = 25 milliards de combinaisons possibles }

  type_homme     = set of (anglais,suedois,danois,norvegien,allemand) ;
  type_boisson   = set of (the,cafe,eau,lait,biere) ;
  type_cigarette = set of (pall_mall,dunhills,blends,blue_masters,prince) ;
  type_animal    = set of (chiens,oiseaux,chats,chevaux,poissons) ;
  type_couleur   = set of (rouge,verte,blanche,jaune,bleue) ;
  maison         = record
                   couleur   : type_couleur ;
                   homme     : type_homme ;
                   boisson   : type_boisson ;
                   cigarette : type_cigarette ;
                   animal    : type_animal ;
                   end ;

var
  Form1        : TForm1;
  maisons      : array[1..5] of maison ;
  permutations : tstringlist ;

implementation

{$R *.DFM}

function conditions(nb : integer) : boolean ;
var ok : array[1..15] of boolean ;
    i : integer ;
begin
for i:=1 to 15 do ok[i]:=false ;
for i:=1 to 5 do
    case nb of
     1 : if (maisons[i].homme=[anglais]) and (maisons[i].couleur=[rouge ]) then ok[1]:=true ;
     2 : if (maisons[i].homme=[suedois]) and (maisons[i].animal =[chiens]) then ok[2]:=true ;
     3 : if (maisons[i].homme=[danois ]) and (maisons[i].boisson=[the   ]) then ok[3]:=true ;
     4 : if (i>1) and (maisons[i].couleur=[blanche]) and (maisons[i-1].couleur=[verte]) then ok[4]:=true ;
     5 : if (maisons[i].couleur=[verte]) and (maisons[i].boisson=[cafe]) then ok[5]:=true ;
     6 : if (maisons[i].cigarette=[pall_mall]) and (maisons[i].animal=[oiseaux]) then ok[6]:=true ;
     7 : if (maisons[i].cigarette=[dunhills ]) and (maisons[i].couleur=[jaune ]) then ok[7]:=true ;
     8 : if (maisons[3].boisson=[lait]) then ok[8]:=true ;
     9 : if (maisons[1].homme=[norvegien]) then ok[9]:=true ;
    10 : if (maisons[i].animal=[chats]) then
            begin
            if (i<5) and (maisons[i+1].cigarette=[blends]) then ok[10]:=true ;
            if (i>1) and (maisons[i-1].cigarette=[blends]) then ok[10]:=true ;
            end ;
    11 : if (maisons[i].cigarette=[dunhills]) then
            begin
            if (i<5) and (maisons[i+1].animal=[chevaux]) then ok[11]:=true ;
            if (i>1) and (maisons[i-1].animal=[chevaux]) then ok[11]:=true ;
            end ;
    12 : if (maisons[i].cigarette=[blue_masters]) and (maisons[i].boisson=[biere]) then ok[12]:=true ;
    13 : if (maisons[i].homme=[allemand]) and (maisons[i].cigarette=[prince]) then ok[13]:=true ;
    14 : if (maisons[i].couleur=[bleue]) then
            begin
            if (i<5) and (maisons[i+1].homme=[norvegien]) then ok[14]:=true ;
            if (i>1) and (maisons[i-1].homme=[norvegien]) then ok[14]:=true ;
            end ;
    15 : if (maisons[i].cigarette=[blends]) then
            begin
            if (i<5) and (maisons[i+1].boisson=[eau]) then ok[15]:=true ;
            if (i>1) and (maisons[i-1].boisson=[eau]) then ok[15]:=true ;
            end ;
    end ;
conditions:=ok[nb] ;
end ;

procedure init_maison(var m : maison ;n,p : integer) ;
begin
if n=1 then  // couleur maison
   begin
   case p of
     1 : m.couleur:=[rouge] ;
     2 : m.couleur:=[verte] ;
     3 : m.couleur:=[blanche] ;
     4 : m.couleur:=[jaune] ;
     5 : m.couleur:=[bleue] ;
     end
   end ;
if n=2 then  //  type_homme
   begin
   case p of
     1 : m.homme:=[anglais] ;
     2 : m.homme:=[suedois] ;
     3 : m.homme:=[danois] ;
     4 : m.homme:=[norvegien] ;
     5 : m.homme:=[allemand] ;
     end
   end ;
if n=3 then  //  type boisson
   begin
   case p of
     1 : m.boisson:=[the] ;
     2 : m.boisson:=[cafe] ;
     3 : m.boisson:=[eau] ;
     4 : m.boisson:=[lait] ;
     5 : m.boisson:=[biere] ;
     end
   end ;
if n=4 then  //  type cigarette
   begin
   case p of
     1 : m.cigarette:=[pall_mall] ;
     2 : m.cigarette:=[dunhills] ;
     3 : m.cigarette:=[blends] ;
     4 : m.cigarette:=[blue_masters] ;
     5 : m.cigarette:=[prince] ;
     end
   end ;
if n=5 then  //  type animal
   begin
   case p of
     1 : m.animal:=[chiens] ;
     2 : m.animal:=[oiseaux] ;
     3 : m.animal:=[chats] ;
     4 : m.animal:=[chevaux] ;
     5 : m.animal:=[poissons] ;
     end
   end ;
end ;

procedure affiche_solution ;
var i : integer ;
begin
for i:=1 to 5 do
    if maisons[i].animal=[poissons] then
       if maisons[i].homme=[anglais]   then form1.edit1.text:='anglais'   else
       if maisons[i].homme=[suedois]   then form1.edit1.text:='suedois'   else
       if maisons[i].homme=[danois]    then form1.edit1.text:='danois'    else
       if maisons[i].homme=[norvegien] then form1.edit1.text:='norvegien' else
       if maisons[i].homme=[allemand]  then form1.edit1.text:='allemand' ;
end ;

procedure chercher ;
var a,b,c,d,e,i,k,nb : integer ;
    s : string ;
    c1 : type_couleur ;
begin
nb:=permutations.count-1 ;
c1:=[rouge]  ;
for a:=0 to nb do  // couleur maison
    begin
    s:=permutations[a] ;
    for i:=1 to 5 do init_maison(maisons[i],1,strtoint(s[i])) ;
    if conditions(4) then
       for b:=0 to nb do  // homme
           begin
           s:=permutations[b] ;
           for i:=1 to 5 do init_maison(maisons[i],2,strtoint(s[i])) ;
           if conditions( 1) then
           if conditions( 9) then
           if conditions(14) then
              for c:=0 to nb do  // boisson
                  begin
                  s:=permutations[c] ;
                  for i:=1 to 5 do init_maison(maisons[i],3,strtoint(s[i])) ;
                  if conditions(3) then
                  if conditions(5) then
                  if conditions(8) then
                     for d:=0 to nb do  // cigarette
                         begin
                         s:=permutations[d] ;
                         for i:=1 to 5 do init_maison(maisons[i],4,strtoint(s[i])) ;
                         if conditions(7) then
                         if conditions(12) then
                         if conditions(13) then
                         if conditions(15) then
                            for e:=0 to nb do  // animal
                                begin
                                s:=permutations[e] ;
                                for i:=1 to 5 do init_maison(maisons[i],5,strtoint(s[i])) ;

                                k:=(((a*120+b)*120+c)*120+d)*120+e ;
//                                if k mod 100000=0 then
                                   begin
                                   form1.edit1.text:=inttostr(k)+' ; a='+inttostr(a) ;
                                   form1.edit1.refresh ;
                                   end ;

                                if conditions(2) then
                                if conditions(6) then
                                if conditions(10) then
                                if conditions(11) then
                                   begin
                                   affiche_solution ;
                                   exit ;
                                   end ;
                                end ;
                         end ;
                  end ;
           end ;
    end ;
end ;

procedure TForm1.FormCreate(Sender: TObject);
   procedure anagrammes(st,tete : string) ;
   var i : integer ;
   begin
   if length(st)=1 then
      permutations.add(tete+st)
   else
      for i:=1 to length(st) do
          begin
          anagrammes(copy(st,2,length(st)-1),tete+st[1]) ;
          st:=copy(st,2,length(st)-1)+st[1] ;
          end ;
   end ;
begin
permutations:=tstringList.create ;
anagrammes('12345','') ;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
permutations.destroy ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
close ;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
chercher ;
end;

end.
